// pages/login/index.js
let app = getApp();

Page({
  /**
   * 页面的初始数据
   */
  data: {},

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.login(options);
  },

  async login(query) {
    let isLogin = false;
    let hasUser = false;
    // 登录
    const loginRes = await new Promise((resolve, reject) => {
      wx.login({
        success: (res) => resolve(res),
        error: (e) => reject(e),
      });
    });
    if (loginRes) isLogin = true;
    // 获取用户信息
    const userRes = await new Promise((resolve, reject) => {
      wx.getSetting({
        success: (res) => {
          if (res.authSetting["scope.userInfo"]) {
            // 已经授权，可以直接调用 getUserInfo 获取头像昵称，不会弹框
            wx.getUserInfo({
              success: (res) => {
                // 可以将 res 发送给后台解码出 unionId
                app.globalData.userInfo = res.userInfo;
                resolve(res.userInfo);

                // 由于 getUserInfo 是网络请求，可能会在 Page.onLoad 之后才返回
                // 所以此处加入 callback 以防止这种情况
                if (this.userInfoReadyCallback) {
                  this.userInfoReadyCallback(res);
                }
              },
            });
          }
        },
      });
    });
    if (userRes) {
      hasUser = true;
      console.log(loginRes);
      console.log(userRes);
    }
    if (isLogin && hasUser) {
      // TODO:处理query:固定参数:route,为应该跳转的页面
      let { route } = query;
      if (!route) route = "/pages/index/index";
      wx.redirectTo({
        url: route,
      });
    } else this.login(query);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {},

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {},

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {},

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {},
});
