// pages/market/index.js
let app = getApp();

Page({
  /**
   * 页面的初始数据
   */
  data: {
    active: 0,
    tagList: [],
    goodsList: [],
    view: "",
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.search();
  },

  menuChange({ detail }) {
    const tag = this.data.tagList[detail];
    if (!tag) {
      console.warn("未找到标签");
      return;
    }
    const { key } = tag;
    if (!key) {
      console.warn("未找到标签对应的key,无法跳转");
      return;
    }
    this.setData({ view: key });
  },

  async search() {
    // TODO 查詢菜單,整理,暫時先模拟数据

    this.setData({
      tagList: this.imitateTagList(),
      goodsList: this.imitateGoodsList(),
    });
  },
  async onSubmit() {
    console.log("in function:onSubmit");
    // 支付页面
    const path = "/pages/pay/index";
    wx.redirectTo({
      url: path,
    });
  },

  // 模拟标签
  imitateTagList() {
    return [
      { title: "折扣", key: "discount" },
      { title: "推荐", key: "recommend" },
      { title: "酒水", key: "drink" },
      { title: "零食", key: "snack" },
    ];
  },
  // 模拟货物
  imitateGoodsList() {
    const tagList = this.imitateTagList();
    const goodsList = tagList.map((i) => {
      let index = 1;
      const { title, key } = i;
      const goods = [];
      while (index <= 10) {
        goods.push({
          name: `${title}商品-${index}`,
          id: `${key}-${index}`,
          money: Math.ceil(Math.random() * 10),
          images: [{ url: "https://img.yzcdn.cn/vant/cat.jpeg" }],
          tags: ["1人份", "220ml", "微甜", "220ml", "微甜", "220ml", "微甜", "220ml", "微甜", "220ml", "微甜", "220ml", "微甜", "220ml"],
        });
        index++;
      }
      i.goods = goods;
      return i;
    });
    return goodsList;
  },
});
