// pages/pay/index.js
let app = getApp();

Page({
  /**
   * 页面的初始数据
   */
  data: {
    address: {},
    goods: [],
    remark: "",
    addressDialog: false,
    addressList: [
      {
        id: 0,
        is_default: true,
        tags: ["公司"],
        position: "吉林省长春市朝阳区城区",
        place: "前进大街1244号吉林省科技厅科研园小二楼",
        contact: "刘 睿峰",
        gender: "男",
        phone: "13012345612",
      },
      {
        id: 1,
        is_default: false,
        tags: ["家"],
        position: "吉林省长春市朝阳区城区",
        place: "不告诉你",
        contact: "刘 XX",
        gender: "女",
        phone: "13012345612",
      },
    ],
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.init();
  },

  async init() {
    this.initAddress();
    const arr = [];
    for (let i = 0; i < 3; i++) {
      const good = {
        num: i + 1,
        price: (i + 1) * 10,
        title: `商品${i + 1}`,
        thumb: "https://img.yzcdn.cn/vant/cat.jpeg",
      };
      arr.push(good);
    }
    let address = this.data.addressList[0];
    this.setData({ goods: arr, address });
  },
  initAddress() {
    let addressList = [
      {
        id: 0,
        is_default: true,
        tags: ["公司"],
        position: "吉林省长春市朝阳区城区",
        place: "前进大街1244号吉林省科技厅科研园小二楼",
        contact: "刘 睿峰",
        gender: "男",
        phone: "13012345612",
      },
      {
        id: 1,
        is_default: false,
        tags: ["家"],
        position: "吉林省长春市朝阳区城区",
        place: "不告诉你",
        contact: "刘 XX",
        gender: "女",
        phone: "13012345612",
      },
    ];
    addressList = addressList.map((i) => this.addressDisplay(i));
    this.setData({ addressList });
  },

  addressChange(event) {
    // 选择的索引
    const { detail } = event;
    const address = this.data.addressList[detail];
    this.setData({ address });
    this.toAddressSelect();
  },

  //地址编辑
  addressEdit(event) {
    const params = app.getData(event);
    console.log("in function:地址编辑");
    console.log(params);
  },
  //处理地址显示问题
  addressDisplay(address) {
    if (!address) return;
    const { contact, gender, phone } = address;
    if (gender === "男") address.d_contact = `${contact.slice(0, 1)} 先生`;
    else address.d_contact = `${contact.slice(0, 1)} 女士`;
    if (phone) address.d_phone = `${phone.slice(0, 3)}****${phone.slice(7)}`;
    return address;
  },
  //选择地址
  toAddressSelect() {
    this.setData({ addressDialog: !this.data.addressDialog });
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {},
});
