// pages/place/index.js
let app = getApp();

Page({
  /**
   * 页面的初始数据
   */
  data: {
    dialog: false,
    addressList: [],
    form: {gender:"先生"},
    fields: [
      { label: "收货地址", model: "address" },
      { label: "联系人", model: "contact" },
      { label: "性别", model: "gender" },
      { label: "手机号", model: "phone" },
      { label: "标签", model: "tags" },
    ],
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.init();
  },
  init() {
    let addressList = [
      {
        id: 0,
        is_default: true,
        tags: ["公司"],
        position: "吉林省长春市朝阳区城区",
        place: "前进大街1244号吉林省科技厅科研园小二楼",
        contact: "刘",
        gender: "先生",
        phone: "13012345612",
      },
      {
        id: 1,
        is_default: false,
        tags: ["家"],
        position: "吉林省长春市朝阳区城区",
        place: "不告诉你",
        contact: "刘",
        gender: "女士",
        phone: "13012345612",
      },
    ];
    addressList = addressList.map((i) => this.addressDisplay(i));
    this.setData({ addressList });
  },
  //处理地址显示问题
  addressDisplay(address) {
    if (!address) return;
    const { contact, gender, phone } = address;
    address.d_contact = `${contact.slice(0, 1)} ${gender}`;
    if (phone) address.d_phone = `${phone.slice(0, 3)}****${phone.slice(7)}`;
    return address;
  },

  addressEdit(event) {
    const { data } = app.getData(event);
    if (data) this.setData({ form: data });
    this.toAdd();
  },
  toAdd() {
    this.setData({ dialog: true });
  },
  onChange(event) {
    const { model } = app.getData(event);
    const value = event.detail;
    const form = this.data.form;
    form[model] = value;
    this.setData({ form });
  },
});
